/* ===========================================================
	* trumbowyg.noembed.js v1.0
	* noEmbed plugin for Trumbowyg
	* http://alex-d.github.com/Trumbowyg
	* ===========================================================
	* Author : Jake Johns (jakejohns)
*/

(function ($) {
    'use strict';
	
	var reUrlYoutube = /https?:\/\/(?:[0-9A-Z-]+\.)?(?:youtu\.be\/|youtube\.com\S*[^\w\-\s])([\w\-]{11})(?=[^\w\-]|$)(?![?=&+%\w.-]*(?:['"][^<>]*>|<\/a>))[?=&+%\w.-]*/ig;
	var reUrlVimeo = /https?:\/\/(www\.)?vimeo.com\/(\d+)($|\/)/;
	var reUrlFacebook = /^(?:(?:https|http)?:\/\/)?(?:www\.)?(?:facebook\.com(?:\/[^\/]+\/videos\/|\/video\.php\?v=))([0-9]+)(?:.+)?$/;
	
    var defaultOptions = {
        proxy: 'https://noembed.com/embed?nowrap=on',
        urlFiled: 'url',
        data: [],
        success: undefined,
        error: undefined
	};
	
    $.extend(true, $.trumbowyg, {
        langs: {
            en: {
                noembed: 'Noembed',
                noembedError: 'Error'
			},
            sk: {
                noembedError: 'Chyba'
			},
            fr: {
                noembedError: 'Erreur'
			},
            cs: {
                noembedError: 'Chyba'
			},
            ru: {
                noembedError: 'Ошибка'
			},
            ja: {
                noembedError: 'エラー'
			},
            tr: {
                noembedError: 'Hata'
			}
		},
		
        plugins: {
            noembed: {
                init: function (trumbowyg) {
                    trumbowyg.o.plugins.noembed = $.extend(true, {}, defaultOptions, trumbowyg.o.plugins.noembed || {});
					
                    var btnDef = {
                        fn: function () {
                            var $modal = trumbowyg.openModalInsert(
							// Title
							trumbowyg.lang.noembed,
							
							// Fields
							{
								url: {
									label: 'URL',
									required: true
								}
							},
							
							// Callback
							function (data) {
									
									var iframeStart = '<iframe width="500" height="281" src="',
									iframeEnd = '" frameborder="0" allowfullscreen></iframe>';
									
									if (data.url.match(reUrlYoutube))
									{
										data.url = data.url.replace(reUrlYoutube, iframeStart + '//www.youtube.com/embed/$1' + iframeEnd);
									}
									else if (data.url.match(reUrlVimeo))
									{
										data.url = data.url.replace(reUrlVimeo, iframeStart + '//player.vimeo.com/video/$2' + iframeEnd);
									}
									else if (data.url.match(reUrlFacebook))
									{
										data.url = data.url.replace(reUrlFacebook, iframeStart + 'https://www.facebook.com/video/embed?video_id=$1' + iframeEnd);
									} else {
									var error = true
									}
									
									console.log(data);
									if (!error) {
										trumbowyg.execCmd('insertHTML', data.url);
										setTimeout(function () {
											trumbowyg.closeModal();
										}, 250);
										} else {
											trumbowyg.addErrorOnModalField(
											$('input[type=text]', $modal),
											trumbowyg.lang.noembedError
											);
										
									}
								
							}
                            );
						}
					};
					
                    trumbowyg.addBtnDef('noembed', btnDef);
				}
			}
		}
	});
})(jQuery);
