/* ===========================================================
	* trumbowyg.pasteembed.js v1.0
	* Url paste to iframe with noembed. Plugin for Trumbowyg
	* http://alex-d.github.com/Trumbowyg
	* ===========================================================
	* Author : Max Seelig
	*          Facebook : https://facebook.com/maxse
	*          Website : https://www.maxmade.nl/
*/

(function($) {
    'use strict';
	
	var reUrlYoutube = /https?:\/\/(?:[0-9A-Z-]+\.)?(?:youtu\.be\/|youtube\.com\S*[^\w\-\s])([\w\-]{11})(?=[^\w\-]|$)(?![?=&+%\w.-]*(?:['"][^<>]*>|<\/a>))[?=&+%\w.-]*/ig;
	var reUrlVimeo = /https?:\/\/(www\.)?vimeo.com\/(\d+)($|\/)/;
	var reUrlFacebook = /^(?:(?:https|http)?:\/\/)?(?:www\.)?(?:facebook\.com(?:\/[^\/]+\/videos\/|\/video\.php\?v=))([0-9]+)(?:.+)?$/;
	
    var defaultOptions = {
        enabled: true,
        
	};
	
    $.extend(true, $.trumbowyg, {
        plugins: {
            pasteEmbed: {
                init: function(trumbowyg) {
                    trumbowyg.o.plugins.pasteEmbed = $.extend(true, {}, defaultOptions, trumbowyg.o.plugins.pasteEmbed || {});
					
                    if (!trumbowyg.o.plugins.pasteEmbed.enabled) {
                        return;
					}
					
                    trumbowyg.pasteHandlers.push(function(pasteEvent) {
                        try {
                            var clipboardData = (pasteEvent.originalEvent || pasteEvent).clipboardData,
							pastedData = clipboardData.getData('Text'),
							request = null;
							
                            if (pastedData.startsWith('http')) {
                                pasteEvent.stopPropagation();
                                pasteEvent.preventDefault();
								
                                
								var iframeStart = '<iframe width="500" height="281" src="',
								iframeEnd = '" frameborder="0" allowfullscreen></iframe>';
								
								if (pastedData.match(reUrlYoutube))
								{
									pastedData = pastedData.replace(reUrlYoutube, iframeStart + '//www.youtube.com/embed/$1' + iframeEnd);
								}
								else if (pastedData.match(reUrlVimeo))
								{
									pastedData = pastedData.replace(reUrlVimeo, iframeStart + '//player.vimeo.com/video/$2' + iframeEnd);
								}
								else if (pastedData.match(reUrlFacebook))
								{
									pastedData = pastedData.replace(reUrlFacebook, iframeStart + 'https://www.facebook.com/video/embed?video_id=$1' + iframeEnd);
								}
								
								trumbowyg.execCmd('insertHTML', pastedData);
								
                                
							}
						} catch (c) {}
					});
				}
			}
		}
	});
})(jQuery);
